
library("bnlearn")
setwd("symmetry/")

# a simple approach to study the differences between the Bayesian networks
# learned with and without backtracking optimisations.
load("alarm.rda")
sim = rbn(bn, n = round(0.1 * nparams(bn)))
skel.orig = skeleton(si.hiton.pc(sim, test = "mi", alpha = 0.01,
  optimized = FALSE))
skel.back = skeleton(si.hiton.pc(sim, test = "mi", alpha = 0.01,
  optimized = TRUE))
revsim = sim[, rev(seq(ncol(sim)))]
rskel.orig <- skeleton(si.hiton.pc(revsim, test = "mi", alpha = 0.01,
  optimized = FALSE))
rskel.back <- skeleton(si.hiton.pc(revsim, test = "mi", alpha = 0.01,
  optimized = TRUE))
hamming(skel.orig, rskel.orig)
hamming(skel.back, rskel.back)

# sequential versus parallel neighbourhood learning.
sapply(names(learning.test),
  function(node) {
    learn.nbr(learning.test, node = node, method = "si.hiton.pc")
  })
library("parallel")
cl = makeCluster(2)
clusterEvalQ(cl, library("bnlearn"))
parSapply(cl, names(learning.test),
  function(node) {
    learn.nbr(learning.test, node = node, method = "si.hiton.pc")
  })

# checking how tests are distributed among slave processes started by the
# "parallel" library. 
data("alarm")
library("parallel")
cl = makeCluster(2)
res = inter.iamb(alarm, cluster = cl)
unlist(clusterEvalQ(cl, test.counter()))
stopCluster(cl)
cl = makeCluster(3)
res = inter.iamb(alarm, cluster = cl)
unlist(clusterEvalQ(cl, test.counter()))
stopCluster(cl)
cl = makeCluster(4)
res = inter.iamb(alarm, cluster = cl)
unlist(clusterEvalQ(cl, test.counter()))
stopCluster(cl)

