library(bnlearn)

rda = system("ls -1 *.rda", intern = TRUE)

options("stringsAsFactors" = FALSE)

algo = get(commandArgs()[7])
mult = as.numeric(commandArgs()[8])

d = data.frame(
  algorithm = character(0),
  bn = character(0),
  sample = numeric(0),
  flip = numeric(0),
  flip2 = numeric(0)
)

options(error = recover)

alpha = 0.01
reps = 20

for (file in rda) {

  load(file)
  n = ceiling(min(nparams(bn) * mult, 2 * 10^5))
  print(n)
  print(file)

  for (i in seq(reps)) {

    sim = rbn(bn, n = n)

    skel.orig = skeleton(algo(sim, optimized = FALSE, alpha = alpha))
    true = bn.net(bn)
    skel.back = skeleton(algo(sim, optimized = TRUE, alpha = alpha))
    rskel.orig = skeleton(algo(sim[, rev(names(sim))], optimized = FALSE, alpha = alpha))
    rskel.back = skeleton(algo(sim[, rev(names(sim))], optimized = TRUE, alpha = alpha))

    d = rbind(d, list(algorithm = toupper(commandArgs()[6]), 
         bn = file, sample = n, 
         flip = hamming(skel.orig, rskel.orig),
         flip2 = hamming(skel.back, rskel.back)
       ))

    write.table(d, file = paste(toupper(commandArgs()[6]), mult, "log", sep = "."), 
      row.names = FALSE)

  }#FOR

}#FOR

